<!DOCTYPE html>
<html lang="en">
  <head>
  <meta charset="utf-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0">

  <title>Hello World</title>
  <meta property="og:title" content="Hello World" />
  <meta name="twitter:title" content="Hello World" />
  <meta name="description" content="Welcome to the inaugural post of the Mech language blog, where I will be documenting my work on the language as I go. In this first post, I will just talk a little about what the language is for, and where I&rsquo;ll be taking it in the near future. You can also follow Mech&rsquo;s development on Twitter (@MechLang) or by signing up for the mailing list.
What&rsquo;s Mech? I&rsquo;m developing Mech as a domain specific language for a project I&rsquo;m working on, the essence of which I hope will map to problems people would like to solve in general.">
  <meta property="og:description" content="Welcome to the inaugural post of the Mech language blog, where I will be documenting my work on the language as I go. In this first post, I will just talk a little about what the language is for, and where I&rsquo;ll be taking it in the near future. You can also follow Mech&rsquo;s development on Twitter (@MechLang) or by signing up for the mailing list.
What&rsquo;s Mech? I&rsquo;m developing Mech as a domain specific language for a project I&rsquo;m working on, the essence of which I hope will map to problems people would like to solve in general.">
  <meta name="twitter:description" content="Welcome to the inaugural post of the Mech language blog, where I will be documenting my work on the language as I go. In this first post, I will just talk a little about what the language is for, and …">
  <meta name="author" content="Corey Montella"/>
  <link href='https://mech-lang.org/img/favicon.ico' rel='icon' type='image/x-icon'/>
  <meta name="twitter:card" content="summary" />
  <meta property="og:url" content="https://mech-lang.org/post/2018-06-07-hello-world/" />
  <meta property="og:type" content="website" />
  <meta property="og:site_name" content="The Mech Programming Language" />

  <meta name="generator" content="Hugo 0.54.0" />
  <link rel="canonical" href="https://mech-lang.org/post/2018-06-07-hello-world/" />
  <link rel="alternate" href="https://mech-lang.org/index.xml" type="application/rss+xml" title="The Mech Programming Language">
  <link rel="stylesheet" href="https://mech-lang.org/css/main.css"/>
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lora:400,700,400italic,700italic" />
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:300italic,400italic,600italic,700italic,800italic,400,300,600,700,800" />
  <link rel="stylesheet" href="https://mech-lang.org/css/pygment_highlights.css" />
  <link rel="stylesheet" href="https://mech-lang.org/css/highlight.min.css" />

<script type="application/javascript">
var doNotTrack = false;
if (!doNotTrack) {
	window.ga=window.ga||function(){(ga.q=ga.q||[]).push(arguments)};ga.l=+new Date;
	ga('create', 'UA-120731667-1', 'auto');
	
	ga('send', 'pageview');
}
</script>
<script async src='https://www.google-analytics.com/analytics.js'></script>

</head>

  <body>
    <div class="black-bar">

</div>
<nav class="navbar">

  <div class="navbar-header">
      
        <a class="navbar-brand" href="https://mech-lang.org"><img class="logo-nav" src="https://mech-lang.org/img/logo.png" /></a>
      
  </div>
  <div class="spacer"></div>
  <div class="collapse navbar-collapse" id="main-navbar">
    <ul class="nav navbar-nav navbar-right">
      <li>
        <a title="Community" href="https://mech-lang.org/page/community/">Community</a>
      </li>
      <li>
        <a title="Learn" href="https://mech-lang.org/page/learn/">Learn</a>
      </li>
      <li>
        <a title="Blog" href="https://mech-lang.org/blog/">Blog</a>
      </li>
      <li>
        <a title="Try" href="http://try.mech-lang.org">Try</a>
      </li>
    </ul>
  </div>

</nav>




    
  
  
  




  



    
<div class="container">
  <div class="row">
    <div class="col-lg-8 col-lg-offset-2 col-md-10 col-md-offset-1">
      <div>
        <h2 class="post-title"># Hello World</h2>
      </div>
      <span class="post-meta">
  June 7, 2018
  
</span>


      <article role="main" class="blog-post">
        

<p>Welcome to the inaugural post of the Mech language blog, where I will be documenting my work on the language as I go. In this first post, I will just talk a little about what the language is for, and where I&rsquo;ll be taking it in the near future. You can also follow Mech&rsquo;s development on Twitter (<a href="https://twitter.com/MechLang">@MechLang</a>) or by signing up for the <a href="https://mech-lang.org/page/community/">mailing list</a>.</p>

<h2 id="what-s-mech">What&rsquo;s Mech?</h2>

<p>I&rsquo;m developing Mech as a domain specific language for a project I&rsquo;m working on, the essence of which I hope will map to problems people would like to solve in general. The project I&rsquo;m working on is a system consisting of the three interconnected components:</p>

<p>First, I have a small <a href="https://vaderlab.wordpress.com/roscar-robot-stock-car-autonomous-racing/">robot car platform</a> with several sensors, including a Kinect 2 and a 9-axis AHRS. These sensors stream 3D depth information about the environment, and 9D orientation information about the robot&rsquo;s pose. On-board processing of this data is handled by a standard AMD x86_64 CPU.</p>

<p>Next, I have a tablet to which I would like to stream data from the robot. The tablet will display the sensor data, transform and filter it, and send it back to the robot. The final piece of the system is a server, which will host long-running computations like <a href="https://en.wikipedia.org/wiki/Simultaneous_localization_and_mapping">SLAM</a> or neural net model training. The server can communicate with the tablet or the car directly. In summary, the system looks like this:</p>

<p><img src="https://mech-lang.org/img/post/topology.png" /></p>

<p>Mech is therefore a platform that allows me to work with the system described above with the minimum amount of coding. The platform should handle all the heavy lifting in terms of connecting to devices, shuffling data around, providing transforms and visualizations, and it should all be fast enough for a robotics-focused application.</p>

<p>(At this point many of you may be tempted to make a list of various <a href="http://www.ros.org">technologies</a> or platforms that when cobbled together could facilitate such a project. I&rsquo;ll detail it in another post, but I&rsquo;ve already built an off-the-shelf system that I ultimately found wanting. That&rsquo;s the reason I&rsquo;m building something from scratch.)</p>

<h3 id="requirements">Requirements</h3>

<p>Let&rsquo;s break out the essential properties of the system I described above, so we know the important properties of the language we&rsquo;re about to build.</p>

<ul>
<li><strong>All streams all day</strong> - Data in this system are mostly matrices or vectors. Thus, Mech should be especially well suited to working with these data types.</li>
<li><strong>Distributed</strong> - Computation happens on loosely coupled network of computing resources. The platform should make it easy to distribute computations and data to various locations. Work is done asynchronously, at different times, at different locations, but that shouldn&rsquo;t stop other work from progressing if it can.</li>
<li><strong>Real-time</strong> - both real-time in the sense that we want the most up-to-date view on data, and real-time in the sense that we want guarantees about the responsiveness of the system when we can. Mech will operate on systems like robot cars where latency does matter.</li>
<li><strong>Reactive</strong> - reacting to changes in data should be a forte of the language. You shouldn&rsquo;t have to specify how data flows, but only what data is flowing. Mech should do everything for you in terms of routing and updating streams and computations.</li>
<li><strong>Time and space matter</strong> - Streams of real-world data represent the physical world, so time and space matter. Streams coming into Mech can represent a quantity &ndash; a value plus a unit. Mech should handle conversions between quantities of different scales (e.g. feet to meters). Similarly with time, Mech should handle time explicitly, allowing you to talk about the <code>previous</code> or <code>next</code> values in a stream.</li>
<li><strong>Visualize Everything</strong> - In a system defined by data flows, bugs are going to exist where streams are incorrectly routed or transformed. Tools capable of visualizing and inspecting streams at any point in time will make debugging this kind of program easier.</li>
</ul>

<h2 id="imagine-the-science-fiction">Imagine the Science Fiction</h2>

<p>We used to do something at Eve where we would imagine a sci-fi future where we had cool computing tools. What kinds of things could we do with those, that we couldn&rsquo;t do today? By imagining this future that didn&rsquo;t exist in explicit terms, we could work backwards and figure out the necessary technologies to make that fiction a reality. I&rsquo;m going to do the same thing here, phrased as two lists: things that an idealized Mech makes trivial, and things that it makes impossible [1]. Here&rsquo;s a chance for us to think big and imagine a future where anything is possible.</p>

<h3 id="mech-makes-it-trivial-to">Mech makes it trivial to&hellip;</h3>

<ul>
<li>&hellip;transform data from one shape into another.</li>
<li>&hellip;visualize anything in multiple ways. Tap on any variable, see its history, overlay it with other variables and track them over time.</li>
<li>&hellip;track down the source of a bug. It points out exactly what piece of code is causing the error, and show the full chain of execution that generated it.</li>
<li>&hellip;share programs with friends or coworkers. Click one button to host online, send a link or text to grant access to a running application.</li>
<li>&hellip;record and playback everything.</li>
<li>&hellip;compose code like snapping together lego bricks. For real this time.</li>
<li>&hellip;scale and distribute your program with a single click.</li>
<li>&hellip;explore different execution paths by allowing you to rewind an execution, change code, and then resume the execution in place.</li>
<li>&hellip;rewind to the past and change the computation graph.</li>
<li>&hellip;use a variety of input methods: mouse, pen, touch, voice, VR, etc.</li>
</ul>

<h3 id="mech-makes-it-impossible-to">Mech makes it impossible to&hellip;</h3>

<ul>
<li>&hellip;write a program that can crash.</li>
<li>&hellip;write a program that can deadlock.</li>
<li>&hellip;corrupt memory or access uninitialized memory.</li>
<li>&hellip;end up with inconsistent state.</li>
<li>&hellip;get stuck at any phase of development.</li>
</ul>

<p>Coming from today&rsquo;s programming language landscape, the above may seem more on the fiction side of things. But it is my hypothesis that all of the above will be achievable with Mech, made possible by the greenfield approach we&rsquo;re taking. As I&rsquo;ll show in the coming blog posts, some of the decisions we make up-front about the semantics of the language will have major implications down the road on what we can achieve with tooling.</p>

<h2 id="conclusion">Conclusion</h2>

<p>Hopefully now you have an idea about the spirit of Mech. This post was really about the motivation for building it and what I hope it will become one day. I hope it was enough to convince you to follow along as we build this language. In the next post I&rsquo;ll talk about specifics of Mech, in terms of its architecture and the implementation as it stands so far.</p>

<p><div class="footnotes">
  <div class="footnote">
  [1] When I worked on it, I was responsible for talking about the Eve language to outside audiences, so I&rsquo;ve spent a lot of time thinking about how people talk about programming languages to one another. This is the first time I&rsquo;m trying this method, but I like it for a couple reasons. First, by talking about what the language makes trivial or impossible, we recognize that implicit in the design of a language is a set of tradeoffs, and we highlight the <em>implications</em> of the design decisions we felt were most significant. Further, a reader of these lists isn&rsquo;t left to wonder how a feature may impact their work. Programming languages are often first presented as a list of supported features, frameworks, or programming paradigms, leaving the user to decide how e.g. &ldquo;trait-based generics&rdquo; impact their work.
  <div>
<div></p>

      </article>
      
        
      

    </div>
  </div>
</div>

    
<script src="https://cdnjs.cloudflare.com/ajax/libs/KaTeX/0.7.1/katex.min.js" integrity="sha384-/y1Nn9+QQAipbNQWU65krzJralCnuOasHncUFXGkdwntGeSvQicrYkiUBwsgUqc1" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/KaTeX/0.7.1/contrib/auto-render.min.js" integrity="sha384-dq1/gEHSxPZQ7DdrM82ID4YVol9BYyU7GbWlIwnwyPzotpoc57wDw/guX8EaYGPx" crossorigin="anonymous"></script>
<script src="https://code.jquery.com/jquery-1.12.4.min.js" integrity="sha256-ZosEbRLbNQzLpnKIkEdrPv7lOy9C27hHQ+Xp8a4MxAQ=" crossorigin="anonymous"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
<script src="https://mech-lang.org/js/main.js"></script>
<script src="https://mech-lang.org/js/highlight.min.js"></script>
<script> hljs.initHighlightingOnLoad(); </script>
<script> renderMathInElement(document.body); </script>





  </body>
</html>

